Index: /trunk/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -46,5 +46,4 @@
 using namespace std;
 
-
 //! \ingroup TLibEncoder
 //! \{
@@ -68,5 +67,5 @@
   m_ppcTempCU      = new TComDataCU*[m_uhTotalDepth-1];
 
-#if NH_3D_ARP
+#if NH_3D
   m_ppcWeightedTempCU = new TComDataCU*[m_uhTotalDepth-1];
 #endif 
@@ -79,5 +78,5 @@
   m_ppcRecoYuvTemp = new TComYuv*[m_uhTotalDepth-1];
   m_ppcOrigYuv     = new TComYuv*[m_uhTotalDepth-1];
-#if NH_3D_DBBP
+#if NH_3D
   m_ppcOrigYuvDBBP = new TComYuv*[m_uhTotalDepth-1];
 #endif
@@ -92,5 +91,5 @@
     m_ppcBestCU[i] = new TComDataCU; m_ppcBestCU[i]->create( chromaFormat, uiNumPartitions, uiWidth, uiHeight, false, uiMaxWidth >> (m_uhTotalDepth - 1) );
     m_ppcTempCU[i] = new TComDataCU; m_ppcTempCU[i]->create( chromaFormat, uiNumPartitions, uiWidth, uiHeight, false, uiMaxWidth >> (m_uhTotalDepth - 1) );
-#if NH_3D_ARP
+#if NH_3D
     m_ppcWeightedTempCU[i] = new TComDataCU; m_ppcWeightedTempCU[i]->create( chromaFormat, uiNumPartitions, uiWidth, uiHeight, false, uiMaxWidth >> (m_uhTotalDepth - 1) );
 #endif  
@@ -105,5 +104,5 @@
 
     m_ppcOrigYuv    [i] = new TComYuv; m_ppcOrigYuv    [i]->create(uiWidth, uiHeight, chromaFormat);
-#if NH_3D_DBBP
+#if NH_3D
     m_ppcOrigYuvDBBP[i] = new TComYuv; m_ppcOrigYuvDBBP[i]->create(uiWidth, uiHeight, chromaFormat);
 #endif
@@ -147,5 +146,5 @@
       m_ppcTempCU[i]->destroy();      delete m_ppcTempCU[i];      m_ppcTempCU[i] = NULL;
     }
-#if NH_3D_ARP
+#if NH_3D
     if(m_ppcWeightedTempCU[i])
     {
@@ -181,5 +180,5 @@
       m_ppcOrigYuv[i]->destroy();     delete m_ppcOrigYuv[i];     m_ppcOrigYuv[i] = NULL;
     }
-#if NH_3D_DBBP
+#if NH_3D
     if(m_ppcOrigYuvDBBP[i])
     {
@@ -199,5 +198,5 @@
   }
 
-#if NH_3D_ARP
+#if NH_3D
   if(m_ppcWeightedTempCU)
   {
@@ -241,5 +240,5 @@
     m_ppcOrigYuv = NULL;
   }
-#if NH_3D_DBBP
+#if NH_3D
   if(m_ppcOrigYuvDBBP)
   {
@@ -266,4 +265,6 @@
 
   m_pcRateCtrl         = pcEncTop->getRateCtrl();
+  m_lumaQPOffset       = 0;
+  initLumaDeltaQpLUT();
 }
 
@@ -281,5 +282,5 @@
   m_ppcTempCU[0]->initCtu( pCtu->getPic(), pCtu->getCtuRsAddr() );
 
-#if NH_3D_ARP
+#if NH_3D
   m_ppcWeightedTempCU[0]->initCtu( pCtu->getPic(), pCtu->getCtuRsAddr() );
 #endif
@@ -329,4 +330,87 @@
 // Protected member functions
 // ====================================================================================================================
+
+Void TEncCu::initLumaDeltaQpLUT()
+{
+  const LumaLevelToDeltaQPMapping &mapping=m_pcEncCfg->getLumaLevelToDeltaQPMapping();
+
+  if ( !mapping.isEnabled() )
+  {
+    return;
+  }
+
+  // map the sparse LumaLevelToDeltaQPMapping.mapping to a fully populated linear table.
+
+  Int         lastDeltaQPValue=0;
+  std::size_t nextSparseIndex=0;
+  for(Int index=0; index<LUMA_LEVEL_TO_DQP_LUT_MAXSIZE; index++)
+  {
+    while (nextSparseIndex < mapping.mapping.size() && index>=mapping.mapping[nextSparseIndex].first)
+    {
+      lastDeltaQPValue=mapping.mapping[nextSparseIndex].second;
+      nextSparseIndex++;
+    }
+    m_lumaLevelToDeltaQPLUT[index]=lastDeltaQPValue;
+  }
+}
+
+Int TEncCu::calculateLumaDQP(TComDataCU *pCU, const UInt absPartIdx, const TComYuv * pOrgYuv)
+{
+  const Pel *pY = pOrgYuv->getAddr(COMPONENT_Y, absPartIdx);
+  const Int stride  = pOrgYuv->getStride(COMPONENT_Y);
+  Int width = pCU->getWidth(absPartIdx);
+  Int height = pCU->getHeight(absPartIdx);
+  Double avg = 0;
+
+  // limit the block by picture size
+  const TComSPS* pSPS = pCU->getSlice()->getSPS();
+  if ( pCU->getCUPelX() + width > pSPS->getPicWidthInLumaSamples() )
+  {
+    width = pSPS->getPicWidthInLumaSamples() - pCU->getCUPelX();
+  }
+  if ( pCU->getCUPelY() + height > pSPS->getPicHeightInLumaSamples() )
+  {
+    height = pSPS->getPicHeightInLumaSamples() - pCU->getCUPelY();
+  }
+
+  // Get QP offset derived from Luma level
+  if ( m_pcEncCfg->getLumaLevelToDeltaQPMapping().mode == LUMALVL_TO_DQP_AVG_METHOD )
+  {
+    // Use avg method
+    Int sum = 0;
+    for (Int y = 0; y < height; y++)
+    {
+      for (Int x = 0; x < width; x++)
+      {
+        sum += pY[x];
+      }
+      pY += stride;
+    }
+    avg = (Double)sum/(width*height);
+  }
+  else
+  {
+    // Use maximum luma value
+    Int maxVal = 0;
+    for (Int y = 0; y < height; y++)
+    {
+      for (Int x = 0; x < width; x++)
+      {
+        if (pY[x] > maxVal)
+        {
+          maxVal = pY[x];
+        }
+      }
+      pY += stride;
+    }
+    // use a percentage of the maxVal
+    avg = (Double)maxVal * m_pcEncCfg->getLumaLevelToDeltaQPMapping().maxMethodWeight;
+  }
+
+  Int lumaIdx = Clip3<Int>(0, Int(LUMA_LEVEL_TO_DQP_LUT_MAXSIZE)-1, Int(avg+0.5) );
+  Int QP = m_lumaLevelToDeltaQPLUT[lumaIdx];
+  return QP;
+}
+
 //! Derive small set of test modes for AMP encoder speed-up
 #if AMP_ENC_SPEEDUP
@@ -420,10 +504,6 @@
   const UInt fastDeltaQPCuMaxSize    = Clip3(sps.getMaxCUHeight()>>sps.getLog2DiffMaxMinCodingBlockSize(), sps.getMaxCUHeight(), 32u);
 
-#if NH_3D_QTL
-#if NH_3D_QTLPC
+#if NH_3D
   Bool  bLimQtPredFalg    = pcPic->getSlice(0)->getQtPredFlag(); 
-#else
-  Bool  bLimQtPredFalg    = false;
-#endif
   TComPic *pcTexture      = rpcBestCU->getSlice()->getTexturePic();
 
@@ -440,5 +520,5 @@
   m_ppcOrigYuv[uiDepth]->copyFromPicYuv( pcPic->getPicYuvOrg(), rpcBestCU->getCtuRsAddr(), rpcBestCU->getZorderIdxInCtu() );
 
-#if NH_3D_QTL  
+#if NH_3D
   Bool    bTrySplit     = true;
   Bool    bTrySplitDQP  = true;
@@ -448,11 +528,9 @@
   Bool    earlyDetectionSkipMode = false;
 
-#if NH_3D_NBDV
+#if NH_3D
   DisInfo DvInfo; 
   DvInfo.m_acNBDV.setZero();
   DvInfo.m_aVIdxCan = 0;
-#if NH_3D_NBDV_REF
   DvInfo.m_acDoNBDV.setZero();
-#endif
 #endif
   const UInt uiLPelX   = rpcBestCU->getCUPelX();
@@ -492,4 +570,15 @@
   }
 
+  if ( m_pcEncCfg->getLumaLevelToDeltaQPMapping().isEnabled() )
+  {
+    if ( uiDepth <= pps.getMaxCuDQPDepth() )
+    {
+      // keep using the same m_QP_LUMA_OFFSET in the same CTU
+      m_lumaQPOffset = calculateLumaDQP(rpcTempCU, 0, m_ppcOrigYuv[uiDepth]);
+    }
+    iMinQP = Clip3(-sps.getQpBDOffset(CHANNEL_TYPE_LUMA), MAX_QP, iBaseQP - m_lumaQPOffset);
+    iMaxQP = iMinQP; // force encode choose the modified QO
+  }
+
   if ( m_pcEncCfg->getUseRateCtrl() )
   {
@@ -502,5 +591,5 @@
   const Int lowestQP = iMinQP; // For TQB, use this QP which is the lowest non TQB QP tested (rather than QP'=0) - that way delta QPs are smaller, and TQB can be tested at all CU levels.
 
-  if ( (pps.getTransquantBypassEnableFlag()) )
+  if ( (pps.getTransquantBypassEnabledFlag()) )
   {
     isAddLowestQP = true; // mark that the first iteration is to cost TQB mode.
@@ -512,5 +601,5 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   Bool bICEnabled = rpcTempCU->getSlice()->getViewIndex() && ( rpcTempCU->getSlice()->getSliceType() == P_SLICE || rpcTempCU->getSlice()->getSliceType() == B_SLICE ) && !rpcTempCU->getSlice()->getIsDepth();
   bICEnabled = bICEnabled && rpcTempCU->getSlice()->getApplyIC();
@@ -536,6 +625,12 @@
         iQP = lowestQP;
       }
-
-#if NH_3D_QTL
+      if ( m_pcEncCfg->getLumaLevelToDeltaQPMapping().isEnabled() && uiDepth <= pps.getMaxCuDQPDepth() )
+      {
+        getSliceEncoder()->updateLambda(pcSlice, iQP);
+      }
+
+
+
+#if NH_3D
       bTrySplit    = true;
 #endif
@@ -555,11 +650,7 @@
 
       rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_QTL
+#if NH_3D
       //logic for setting bTrySplit using the partition information that is stored of the texture colocated CU
-#if H_3D_FCO
-      if(depthMapDetect && !bIntraSliceDetect && !rapPic && ( m_pcEncCfg->getUseQTL() || bLimQtPredFalg ) && pcTexture->getReconMark())
-#else
       if(depthMapDetect && !bIntraSliceDetect && !rapPic && ( m_pcEncCfg->getUseQTL() || bLimQtPredFalg ))
-#endif
       {
         TComDataCU* pcTextureCU = pcTexture->getCtu( rpcBestCU->getCtuRsAddr() ); //Corresponding texture LCU
@@ -592,40 +683,11 @@
 #endif
 
-#if NH_3D_NBDV
+#if NH_3D
       if( rpcTempCU->getSlice()->getSliceType() != I_SLICE )
       {
-#if NH_3D_ARP && NH_3D_IV_MERGE && NH_3D_VSP
         if( rpcTempCU->getSlice()->getIvResPredFlag() || rpcTempCU->getSlice()->getIvMvPredFlag() || rpcTempCU->getSlice()->getViewSynthesisPredFlag() )
-#else 
-#if NH_3D_IV_MERGE && NH_3D_VSP
-        if( rpcTempCU->getSlice()->getIvMvPredFlag() || rpcTempCU->getSlice()->getViewSynthesisPredFlag() )
-#else
-#if NH_3D_ARP && NH_3D_VSP
-        if( rpcTempCU->getSlice()->getIvResPredFlag() || rpcTempCU->getSlice()->getViewSynthesisPredFlag() )
-#else
-#if NH_3D_VSP
-        if( rpcTempCU->getSlice()->getViewSynthesisPredFlag() )
-#else
-#if NH_3D_ARP
-        if( rpcTempCU->getSlice()->getIvResPredFlag() )
-#else
-#if H_3D_IV_MERGE
-        if( rpcTempCU->getSlice()->getVPS()->getIvMvPredFlag(rpcTempCU->getSlice()->getLayerId()) )
-#else
-#if NH_3D_DBBP
-        if( rpcTempCU->getSlice()->getDepthBasedBlkPartFlag() )
-#else
-        if (0)
-#endif
-#endif
-#endif
-#endif
-#endif
-#endif
-#endif
         {
           PartSize ePartTemp = rpcTempCU->getPartitionSize(0);
           rpcTempCU->setPartSizeSubParts(SIZE_2Nx2N, 0, uiDepth);
-#if NH_3D_IV_MERGE
           if (rpcTempCU->getSlice()->getIsDepth() )
           {
@@ -634,6 +696,4 @@
           else
           {
-#endif 
-#if NH_3D_NBDV_REF
             if( rpcTempCU->getSlice()->getDepthRefinementFlag() )
             {
@@ -641,11 +701,8 @@
             }
             else
-#endif 
             {
               rpcTempCU->getDisMvpCandNBDV(&DvInfo);
             }
-#if NH_3D_IV_MERGE
-          }
-#endif
+          }
           rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
           rpcBestCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
@@ -666,5 +723,5 @@
       if( rpcBestCU->getSlice()->getSliceType() != I_SLICE )
       {
-#if NH_3D_IC
+#if NH_3D
         for( UInt uiICId = 0; uiICId < ( bICEnabled ? 2 : 1 ); uiICId++ )
         {
@@ -674,5 +731,5 @@
         if(m_pcEncCfg->getUseEarlySkipDetection())
         {
-#if NH_3D_IC
+#if NH_3D
             rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
 #endif
@@ -683,10 +740,10 @@
           rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );//by Competition for inter_2Nx2N
 #endif
-#if NH_3D_VSP  || NH_3D_DBBP
+#if NH_3D
           rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
         }
         // SKIP
-#if NH_3D_IC
+#if NH_3D
           rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
 #endif
@@ -697,5 +754,5 @@
 
         rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP  || NH_3D_DBBP
+#if NH_3D
         rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -704,5 +761,5 @@
         {
           // 2Nx2N, NxN
-#if NH_3D_IC
+#if NH_3D
             rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
 #endif
@@ -714,15 +771,11 @@
           rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
 #endif
-#if NH_3D_VSP  || NH_3D_DBBP
+#if NH_3D
           rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
-#endif
-#if NH_3D_DBBP
             if( rpcTempCU->getSlice()->getDepthBasedBlkPartFlag() && rpcTempCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
             {
               xCheckRDCostInterDBBP( rpcBestCU, rpcTempCU DEBUG_STRING_PASS_INTO(sDebug), false );
               rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode  );
-#if NH_3D_VSP  || NH_3D_DBBP
               rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
-#endif
             }
 #endif
@@ -733,9 +786,9 @@
           }
         }
-#if NH_3D_IC
+#if NH_3D
         }
 #endif
       }
-#if NH_3D_QTL
+#if NH_3D
       if(depthMapDetect && !bIntraSliceDetect && !rapPic && ( m_pcEncCfg->getUseQTL() || bLimQtPredFalg ))
       {
@@ -757,11 +810,10 @@
     }
 #endif
-#if NH_3D_ENC_DEPTH
+#if NH_3D
     if( rpcBestCU->getSlice()->getIsDepth() && rpcBestCU->getSlice()->isIRAP() )
     {
       earlyDetectionSkipMode = false;
     }
-#endif
-#if NH_3D_DIS
+
     rpcTempCU->initEstData( uiDepth, iMinQP, isAddLowestQP  );
     if( rpcBestCU->getSlice()->getDepthIntraSkipFlag() )
@@ -792,5 +844,5 @@
           {
             if( uiDepth == sps.getLog2DiffMaxMinCodingBlockSize() && doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
                 && bTrySplit
 #endif
@@ -804,5 +856,5 @@
 #endif
               rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
               rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -812,5 +864,5 @@
 
           if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
             && bTryNx2N
 #endif
@@ -823,5 +875,5 @@
 #endif
             rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
             rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -833,5 +885,5 @@
           }
           if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
             && bTry2NxN
 #endif
@@ -846,5 +898,5 @@
 
             rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
             rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -874,5 +926,5 @@
             {
               if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
                 && bTry2NxN
 #endif
@@ -885,5 +937,5 @@
 #endif
                 rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
                 rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -894,5 +946,5 @@
               }
               if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
                 && bTry2NxN
 #endif
@@ -906,5 +958,5 @@
 
                 rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
                 rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -920,5 +972,5 @@
             {
               if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
                 && bTry2NxN
 #endif
@@ -933,5 +985,5 @@
 
                 rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
                 rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -942,5 +994,5 @@
               }
               if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
                 && bTry2NxN
 #endif
@@ -953,5 +1005,5 @@
 #endif
                 rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
                 rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -969,5 +1021,5 @@
             {
               if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
                 && bTryNx2N
 #endif
@@ -981,5 +1033,5 @@
 
                 rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
                 rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -990,5 +1042,5 @@
               }
               if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
                 && bTryNx2N
 #endif
@@ -1001,5 +1053,5 @@
 #endif
                 rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
                 rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -1010,5 +1062,5 @@
             {
               if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
                 && bTryNx2N
 #endif
@@ -1021,5 +1073,5 @@
 #endif
                 rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
                 rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -1030,5 +1082,5 @@
               }
               if(doNotBlockPu
-#if NH_3D_QTL
+#if NH_3D
                 && bTryNx2N
 #endif
@@ -1042,5 +1094,5 @@
 #endif
                 rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
+#if NH_3D
                 rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
 #endif
@@ -1051,35 +1103,30 @@
 
 #else
-#if NH_3D_QTL
+#if NH_3D
             if (bTry2NxN)
             {
 #endif
-
-            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnU );
-            rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
-            rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
-#endif
-            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnD );
-            rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
-            rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
-#endif
-#if NH_3D_QTL
+              xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnU );
+              rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
+#if NH_3D
+              rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
+#endif
+              xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnD );
+              rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
+#if NH_3D
+              rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
             }
             if (bTryNx2N)
             {
 #endif
-            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nLx2N );
-            rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
-            rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
-#endif
-            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nRx2N );
-            rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-#if NH_3D_VSP || NH_3D_DBBP
-            rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
-#endif
-#if NH_3D_QTL
+              xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nLx2N );
+              rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
+#if NH_3D
+              rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
+#endif
+              xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nRx2N );
+              rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
+#if NH_3D
+              rpcTempCU->setDvInfoSubParts(DvInfo, 0, uiDepth);
             }
 #endif
@@ -1093,35 +1140,43 @@
         {
 #endif
-
         // do normal intra modes
         // speedup for inter frames
 
-        if((rpcBestCU->getSlice()->getSliceType() == I_SLICE)                                     ||
-           ((!m_pcEncCfg->getDisableIntraPUsInInterSlices()) && (
-           (rpcBestCU->getCbf( 0, COMPONENT_Y  ) != 0)                                            ||
-          ((rpcBestCU->getCbf( 0, COMPONENT_Cb ) != 0) && (numberValidComponents > COMPONENT_Cb)) ||
-          ((rpcBestCU->getCbf( 0, COMPONENT_Cr ) != 0) && (numberValidComponents > COMPONENT_Cr))   // avoid very complex intra if it is unlikely
- #if NH_3D_ENC_DEPTH
+
+#if MCTS_ENC_CHECK
+        if ( m_pcEncCfg->getTMCTSSEITileConstraint() || (rpcBestCU->getSlice()->getSliceType() == I_SLICE) ||
+             ((!m_pcEncCfg->getDisableIntraPUsInInterSlices()) && (
+             (rpcBestCU->getCbf(0, COMPONENT_Y) != 0) ||
+             ((rpcBestCU->getCbf(0, COMPONENT_Cb) != 0) && (numberValidComponents > COMPONENT_Cb)) ||
+             ((rpcBestCU->getCbf(0, COMPONENT_Cr) != 0) && (numberValidComponents > COMPONENT_Cr))  // avoid very complex intra if it is unlikely
+#else
+        if((rpcBestCU->getSlice()->getSliceType() == I_SLICE)                                        ||
+            ((!m_pcEncCfg->getDisableIntraPUsInInterSlices()) && (
+              (rpcBestCU->getCbf( 0, COMPONENT_Y  ) != 0)                                            ||
+             ((rpcBestCU->getCbf( 0, COMPONENT_Cb ) != 0) && (numberValidComponents > COMPONENT_Cb)) ||
+             ((rpcBestCU->getCbf( 0, COMPONENT_Cr ) != 0) && (numberValidComponents > COMPONENT_Cr))  // avoid very complex intra if it is unlikely
+#endif
+ #if NH_3D
             || rpcBestCU->getSlice()->getIsDepth()
 #endif
             )))
-        {
-#if NH_3D_ENC_DEPTH
-            Bool bOnlyIVP = false;
-            Bool bUseIVP = true;
-            if( (rpcBestCU->getSlice()->getSliceType() != I_SLICE) && 
-                !( (rpcBestCU->getCbf( 0, COMPONENT_Y  ) != 0)                                            ||
-                  ((rpcBestCU->getCbf( 0, COMPONENT_Cb ) != 0) && (numberValidComponents > COMPONENT_Cb)) ||
-                  ((rpcBestCU->getCbf( 0, COMPONENT_Cr ) != 0) && (numberValidComponents > COMPONENT_Cr))   ) &&
-                  (rpcBestCU->getSlice()->getIsDepth() && !(rpcBestCU->getSlice()->isIRAP())) )
-            { 
-              bOnlyIVP = true;
-              bUseIVP = rpcBestCU->getSlice()->getIntraContourFlag();
-            }
-            if( bUseIVP )
-            {
-              xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_2Nx2N DEBUG_STRING_PASS_INTO(sDebug), bOnlyIVP );
-#else
-          xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_2Nx2N DEBUG_STRING_PASS_INTO(sDebug) );
+          {
+#if NH_3D
+          Bool bOnlyIVP = false;
+          Bool bUseIVP = true;
+          if( (rpcBestCU->getSlice()->getSliceType() != I_SLICE) && 
+            !( (rpcBestCU->getCbf( 0, COMPONENT_Y  ) != 0)                                            ||
+            ((rpcBestCU->getCbf( 0, COMPONENT_Cb ) != 0) && (numberValidComponents > COMPONENT_Cb)) ||
+            ((rpcBestCU->getCbf( 0, COMPONENT_Cr ) != 0) && (numberValidComponents > COMPONENT_Cr))   ) &&
+            (rpcBestCU->getSlice()->getIsDepth() && !(rpcBestCU->getSlice()->isIRAP())) )
+          { 
+            bOnlyIVP = true;
+            bUseIVP = rpcBestCU->getSlice()->getIntraContourFlag();
+          }
+          if( bUseIVP )
+          {
+            xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_2Nx2N DEBUG_STRING_PASS_INTO(sDebug), bOnlyIVP );
+#else
+            xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_2Nx2N DEBUG_STRING_PASS_INTO(sDebug) );
 #endif
 #if KWU_RC_MADPRED_E0227
@@ -1133,25 +1188,25 @@
 #endif
 
-          rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
-          if( uiDepth == sps.getLog2DiffMaxMinCodingBlockSize() )
-          {
-#if NH_3D_QTL //Try IntraNxN
+            rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
+            if( uiDepth == sps.getLog2DiffMaxMinCodingBlockSize() )
+            {
+#if NH_3D   //Try IntraNxN
               if(bTrySplit)
               {
 #endif
-            if( rpcTempCU->getWidth(0) > ( 1 << sps.getQuadtreeTULog2MinSize() ) )
-            {
-#if NH_3D_ENC_DEPTH
-              xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_NxN DEBUG_STRING_PASS_INTO(sDebug), bOnlyIVP );
-#else
-              xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_NxN DEBUG_STRING_PASS_INTO(sDebug)   );
+                if( rpcTempCU->getWidth(0) > ( 1 << sps.getQuadtreeTULog2MinSize() ) )
+                {
+#if NH_3D
+                  xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_NxN DEBUG_STRING_PASS_INTO(sDebug), bOnlyIVP );
+#else
+                  xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_NxN DEBUG_STRING_PASS_INTO(sDebug)   );
 #endif        
-              rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
+                  rpcTempCU->initEstData( uiDepth, iQP, bIsLosslessMode );
+                }
+#if NH_3D
+              }
+#endif
             }
-#if NH_3D_QTL
-              }
-#endif
-          }
-#if NH_3D_ENC_DEPTH
+#if NH_3D
           }
 #endif
@@ -1171,5 +1226,4 @@
           if((uiBestBits > uiRawBits) || (rpcBestCU->getTotalCost() > m_pcRdCost->calcRdCost(uiRawBits, 0)))
 #endif
-
           {
             xCheckIntraPCM (rpcBestCU, rpcTempCU);
@@ -1236,4 +1290,10 @@
   }
 
+  if ( m_pcEncCfg->getLumaLevelToDeltaQPMapping().isEnabled() )
+  {
+    iMinQP = Clip3(-sps.getQpBDOffset(CHANNEL_TYPE_LUMA), MAX_QP, iBaseQP - m_lumaQPOffset);
+    iMaxQP = iMinQP;
+  }
+
   if ( m_pcEncCfg->getUseRateCtrl() )
   {
@@ -1251,5 +1311,5 @@
   const Bool bSubBranch = bBoundary || !( m_pcEncCfg->getUseEarlyCU() && rpcBestCU->getTotalCost()!=MAX_DOUBLE && rpcBestCU->isSkipped(0) );
 #endif
-#if NH_3D_QTL
+#if NH_3D
   if( bSubBranch && uiDepth < sps.getLog2DiffMaxMinCodingBlockSize() && (!getFastDeltaQp() || uiWidth > fastDeltaQPCuMaxSize || bBoundary) && bTrySplitDQP )
 #else
@@ -1258,4 +1318,6 @@
   {
     // further split
+    Double splitTotalCost = 0;
+
     for (Int iQP=iMinQP; iQP<=iMaxQP; iQP++)
     {
@@ -1280,5 +1342,5 @@
       DEBUG_STRING_NEW(sTempDebug)
 
-#if NH_3D_ARP
+#if NH_3D
       m_ppcWeightedTempCU[uhNextDepth]->setSlice( m_ppcWeightedTempCU[ uiDepth]->getSlice()); 
       m_ppcWeightedTempCU[uhNextDepth]->setPic  ( m_ppcWeightedTempCU[ uiDepth] ); 
@@ -1318,4 +1380,8 @@
           rpcTempCU->copyPartFrom( pcSubBestPartCU, uiPartUnitIdx, uhNextDepth );         // Keep best part data to current temporary data.
           xCopyYuv2Tmp( pcSubBestPartCU->getTotalNumPart()*uiPartUnitIdx, uhNextDepth );
+          if ( m_pcEncCfg->getLumaLevelToDeltaQPMapping().isEnabled() && pps.getMaxCuDQPDepth() >= 1 )
+          {
+            splitTotalCost += pcSubBestPartCU->getTotalCost();
+          }
         }
         else
@@ -1331,8 +1397,20 @@
         m_pcEntropyCoder->resetBits();
         m_pcEntropyCoder->encodeSplitFlag( rpcTempCU, 0, uiDepth, true );
+        if ( m_pcEncCfg->getLumaLevelToDeltaQPMapping().isEnabled() && pps.getMaxCuDQPDepth() >= 1 )
+        {
+          Int splitBits = m_pcEntropyCoder->getNumberOfWrittenBits();
+          Double splitBitCost = m_pcRdCost->calcRdCost( splitBits, 0 );
+          splitTotalCost += splitBitCost;
+        }
 
         rpcTempCU->getTotalBits() += m_pcEntropyCoder->getNumberOfWrittenBits(); // split bits
         rpcTempCU->getTotalBins() += ((TEncBinCABAC *)((TEncSbac*)m_pcEntropyCoder->m_pcEntropyCoderIf)->getEncBinIf())->getBinsCoded();
       }
+      if ( m_pcEncCfg->getLumaLevelToDeltaQPMapping().isEnabled() && pps.getMaxCuDQPDepth() >= 1 )
+      {
+        rpcTempCU->getTotalCost() = splitTotalCost;
+      }
+      else
+      {
 #if NH_3D_VSO // M10
       if ( m_pcRdCost->getUseLambdaScaleVSO() )
@@ -1343,4 +1421,5 @@
 #endif
         rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
+      }
 
       if( uiDepth == pps.getMaxCuDQPDepth() && pps.getUseDQP())
@@ -1572,5 +1651,5 @@
   }
 
-  if (pps.getTransquantBypassEnableFlag())
+  if (pps.getTransquantBypassEnabledFlag())
   {
     m_pcEntropyCoder->encodeCUTransquantBypassFlag( pcCU, uiAbsPartIdx );
@@ -1591,8 +1670,6 @@
 
     m_pcEntropyCoder->encodeMergeIndex( pcCU, uiAbsPartIdx );
-#if NH_3D_ARP
+#if NH_3D
     m_pcEntropyCoder->encodeARPW( pcCU , uiAbsPartIdx );
-#endif
-#if NH_3D_IC
     m_pcEntropyCoder->encodeICFlag  ( pcCU, uiAbsPartIdx );
 #endif
@@ -1602,50 +1679,44 @@
   }
 
-#if NH_3D_DIS
+#if NH_3D
   m_pcEntropyCoder->encodeDIS( pcCU, uiAbsPartIdx );
   if(!pcCU->getDISFlag(uiAbsPartIdx))
   {
 #endif
-  m_pcEntropyCoder->encodePredMode( pcCU, uiAbsPartIdx );
-  m_pcEntropyCoder->encodePartSize( pcCU, uiAbsPartIdx, uiDepth );
-
-  if (pcCU->isIntra( uiAbsPartIdx ) && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_2Nx2N )
-  {
-    m_pcEntropyCoder->encodeIPCMInfo( pcCU, uiAbsPartIdx );
-
-    if(pcCU->getIPCMFlag(uiAbsPartIdx))
-    {
-#if NH_3D_SDC_INTRA
-      m_pcEntropyCoder->encodeSDCFlag( pcCU, uiAbsPartIdx );
+    m_pcEntropyCoder->encodePredMode( pcCU, uiAbsPartIdx );
+    m_pcEntropyCoder->encodePartSize( pcCU, uiAbsPartIdx, uiDepth );
+
+    if (pcCU->isIntra( uiAbsPartIdx ) && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_2Nx2N )
+    {
+      m_pcEntropyCoder->encodeIPCMInfo( pcCU, uiAbsPartIdx );
+
+      if(pcCU->getIPCMFlag(uiAbsPartIdx))
+      {
+#if NH_3D
+        m_pcEntropyCoder->encodeSDCFlag( pcCU, uiAbsPartIdx );
 #endif  
 
-      // Encode slice finish
-      finishCU(pcCU,uiAbsPartIdx);
-      return;
-    }
-  }
-
-  // prediction Info ( Intra : direction mode, Inter : Mv, reference idx )
-  m_pcEntropyCoder->encodePredInfo( pcCU, uiAbsPartIdx );
-#if NH_3D_DBBP
-  m_pcEntropyCoder->encodeDBBPFlag( pcCU, uiAbsPartIdx );
-#endif
-#if NH_3D_SDC_INTRA
-  m_pcEntropyCoder->encodeSDCFlag( pcCU, uiAbsPartIdx );
-#endif  
-#if NH_3D_ARP
-  m_pcEntropyCoder->encodeARPW( pcCU , uiAbsPartIdx );
-#endif
-#if NH_3D_IC
-  m_pcEntropyCoder->encodeICFlag  ( pcCU, uiAbsPartIdx );
-#endif
-
-  // Encode Coefficients
-  Bool bCodeDQP = getdQPFlag();
-  Bool codeChromaQpAdj = getCodeChromaQpAdjFlag();
-  m_pcEntropyCoder->encodeCoeff( pcCU, uiAbsPartIdx, uiDepth, bCodeDQP, codeChromaQpAdj );
-  setCodeChromaQpAdjFlag( codeChromaQpAdj );
-  setdQPFlag( bCodeDQP );
-#if NH_3D_DIS
+        // Encode slice finish
+        finishCU(pcCU,uiAbsPartIdx);
+        return;
+      }
+    }
+
+    // prediction Info ( Intra : direction mode, Inter : Mv, reference idx )
+    m_pcEntropyCoder->encodePredInfo( pcCU, uiAbsPartIdx );
+#if NH_3D
+    m_pcEntropyCoder->encodeDBBPFlag( pcCU, uiAbsPartIdx );
+    m_pcEntropyCoder->encodeSDCFlag( pcCU, uiAbsPartIdx );
+    m_pcEntropyCoder->encodeARPW( pcCU , uiAbsPartIdx );
+    m_pcEntropyCoder->encodeICFlag  ( pcCU, uiAbsPartIdx );
+#endif
+
+    // Encode Coefficients
+    Bool bCodeDQP = getdQPFlag();
+    Bool codeChromaQpAdj = getCodeChromaQpAdjFlag();
+    m_pcEntropyCoder->encodeCoeff( pcCU, uiAbsPartIdx, uiDepth, bCodeDQP, codeChromaQpAdj );
+    setCodeChromaQpAdjFlag( codeChromaQpAdj );
+    setdQPFlag( bCodeDQP );
+#if NH_3D
   }
 #endif
@@ -1788,5 +1859,5 @@
 #endif
 
-#if NH_3D_MLC
+#if NH_3D
   TComMvField  cMvFieldNeighbours[MRG_MAX_NUM_CANDS_MEM << 1]; // double length for mv of both lists
   UChar uhInterDirNeighbours[MRG_MAX_NUM_CANDS_MEM];
@@ -1803,5 +1874,5 @@
   }
   UChar uhDepth = rpcTempCU->getDepth( 0 );
-#if NH_3D_IC
+#if NH_3D
   Bool bICFlag = rpcTempCU->getICFlag( 0 );
 #endif
@@ -1817,12 +1888,11 @@
 #endif
 
-#if NH_3D_ARP
+#if NH_3D  
   DisInfo cOrigDisInfo = rpcTempCU->getDvInfo(0);
-#else
 #endif
 
   rpcTempCU->setPartSizeSubParts( SIZE_2Nx2N, 0, uhDepth ); // interprets depth relative to CTU level
 
-#if NH_3D_SPIVMP
+#if NH_3D
   Bool bSPIVMPFlag[MRG_MAX_NUM_CANDS_MEM];
   memset(bSPIVMPFlag, false, sizeof(Bool)*MRG_MAX_NUM_CANDS_MEM);
